SystemOrganization addCategory: #'PVpub-AnalogClockPrototype05'!

CircleMorph subclass: #Dial05
	instanceVariableNames: 'boundsLag watchHand interface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype05'!

!Dial05 methodsFor: 'recursive-embedding' stamp: 'pv 12/27/2013 00:41'!
addMorphFront: aMorph 
	(aMorph isKindOf: Dial05)
		ifFalse: [^ super addMorphFront: aMorph].
	^ self pvtInsertBetweenDialAndWatchhand: aMorph! !

!Dial05 methodsFor: 'drawing' stamp: 'pv 12/8/2013 10:08'!
drawOn: aCanvas 
	| resizeFactor |
	resizeFactor := self pvtBoundsResizeFactor.
	resizeFactor ~= 1.0
		ifTrue: [self submorphs
				do: [:each | 
					(each isKindOf: WatchHand05)
						ifTrue: [each isMovingWatchhand
								ifTrue: [each step]].
					(each isKindOf: Dial05)
						ifTrue: [each center: self center + ((each center - self center) * resizeFactor)]].
			self pvtBoundsLag: self bounds].
	super drawOn: aCanvas! !

!Dial05 methodsFor: 'test-interface' stamp: 'pv 12/5/2013 19:58'!
getIf
	^interface! !

!Dial05 methodsFor: 'test-interface' stamp: 'pv 12/4/2013 23:19'!
ifGetWatchhand
	"intended for use by the interface only"
	^ watchHand getMovingWatchhand! !

!Dial05 methodsFor: 'initialization' stamp: 'pv 12/4/2013 22:45'!
initialize
	super initialize.
	self extent: 200 @ 200;
		 position: 300 @ 300;
		 layoutPolicy: ConcentricLayout new.
	boundsLag := 1 @ 1 corner: 2 @ 2.
	self pvtInitializeResizableWatchhand;
		pvtInitializeInterface! !

!Dial05 methodsFor: 'drawing' stamp: 'pv 12/8/2013 09:59'!
pvtBoundsLag: oldBoundsValue 
	boundsLag := oldBoundsValue! !

!Dial05 methodsFor: 'drawing' stamp: 'pv 12/8/2013 10:03'!
pvtBoundsResizeFactor
	| currentExtent oldExtent |
	currentExtent := self bounds corner - self bounds origin.
	oldExtent := boundsLag corner - boundsLag origin.
	^ (currentExtent x / oldExtent x) asFloat! !

!Dial05 methodsFor: 'initialization' stamp: 'pv 12/5/2013 19:55'!
pvtInitializeInterface
	"let the analog clock (Dial05) get steered by Dial05Interface"
	interface := Dial05Interface new.
	interface setIfProxy: self! !

!Dial05 methodsFor: 'initialization' stamp: 'pv 12/4/2013 22:48'!
pvtInitializeResizableWatchhand
	watchHand := ResizableWatchHand05 newFrom: self.
	watchHand
		setInitialMidnightVerticesFromCenter: self center
		andRadius: self extent x / 2
		withFraction: 0.9! !

!Dial05 methodsFor: 'recursive-embedding' stamp: 'pv 12/27/2013 00:40'!
pvtInsertBetweenDialAndWatchhand: aMorph
	^ self privateAddMorph: aMorph atIndex: 3! !

!ConcentricLayout methodsFor: '*pvpub-analogclockprototype05' stamp: 'pv 9/26/2013 23:32'!
isConcentricLayout
	^ true! !

!ConcentricLayout methodsFor: '*pvpub-analogclockprototype05' stamp: 'pv 11/11/2013 23:00'!
layout: aMorph in: newBounds 
	"Compute the layout for those of my submorphs which have
	been added with a LayoutFrame."
	aMorph
		submorphsDo: [:m | m layoutFrame
				ifNotNil: [m layoutConcentricallyIn: newBounds;
						 setRotationCenterFrom: aMorph center]
					]! !

!ConcentricLayout methodsFor: '*pvpub-analogclockprototype05' stamp: 'pv 1/3/2014 01:27'!
minExtentOf: aMorph in: newBounds 
	"Return the minimal size aMorph's children would require
	given the new bounds"
	| min |
	min := 0 @ 0.
	aMorph
		submorphsDo: [:m | 
			| extent frame |
			"Map the minimal size of the child through the layout
			frame. Note: This is done here and not in the child
			because its specific
			for proportional layouts. Perhaps we'll generalize this
			for table
			layouts but I'm not sure how and when."
			"Map the minimal size of the child through the layout
			frame. Note: This is done here and not in the child
			because its specific
			for proportional layouts. Perhaps we'll generalize this
			for table
			layouts but I'm not sure how and when."
			"Map the minimal size of the child through the layout
			frame. Note: This is done here and not in the child
			because its specific
			for proportional layouts. Perhaps we'll generalize this
			for table
			layouts but I'm not sure how and when."
			"Map the minimal size of the child through the layout
			frame. Note: This is done here and not in the child
			because its specific
			for proportional layouts. Perhaps we'll generalize this
			for table
			layouts but I'm not sure how and when."
			extent := m minExtent.
			"Map the minimal size of the child through the layout
			frame. Note: This is done here and not in the child
			because its specific
			for proportional layouts. Perhaps we'll generalize this
			for table
			layouts but I'm not sure how and when."
			"Map the minimal size of the child through the layout
			frame. Note: This is done here and not in the child
			because its specific
			for proportional layouts. Perhaps we'll generalize this
			for table
			layouts but I'm not sure how and when."
			"Map the minimal size of the child through the layout
			frame. Note: This is done here and not in the child
			because its specific
			for proportional layouts. Perhaps we'll generalize this
			for table
			layouts but I'm not sure how and when."
			"Map the minimal size of the child through the layout
			frame. Note: This is done here and not in the child
			because its specific
			for proportional layouts. Perhaps we'll generalize this
			for table
			layouts but I'm not sure how and when."
			frame := m layoutFrame.
			frame
				ifNotNil: [extent := frame minExtentFrom: extent].
			min := min max: extent].
	^ min! !

!Morph methodsFor: '*pvpub-analogclockprototype05' stamp: 'pv 9/2/2013 00:00'!
layoutConcentricallyIn: newBounds 
	"Layout specific. Apply the given bounds to the receiver which
	is a submorph."
	| box frame |
	frame := self layoutFrame
				ifNil: [^ self].
	"before applying the proportional values make sure the
	receiver's layout is computed"
	self fullBounds.
	"sigh..."
	"compute the cell size the receiver has given its layout frame"
	box := frame layout: self bounds given: self owner bounds in: newBounds.
	box = self bounds
		ifTrue: [^ self].
	"no change"
	^ self layoutInBounds: box! !

!LayoutPolicy methodsFor: '*pvpub-analogclockprototype05' stamp: 'pv 9/26/2013 23:37'!
isConcentricLayout
	^ false! !

Object subclass: #Dial05Interface
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype05'!

!Dial05Interface methodsFor: 'initialize-release' stamp: 'pv 12/5/2013 20:09'!
delete
	proxy delete! !

!Dial05Interface methodsFor: 'acessing' stamp: 'pv 12/5/2013 20:12'!
doOneCycleNow
	proxy owner world doOneCycleNow! !

!Dial05Interface methodsFor: 'acessing' stamp: 'pv 12/5/2013 20:18'!
getWatchhand
	^ proxy ifGetWatchhand rotationDegreesFromMidnightPosition! !

!Dial05Interface methodsFor: 'acessing' stamp: 'pv 12/5/2013 19:55'!
setIfProxy: anAnalogClock 
	proxy := anAnalogClock! !

!Dial05Interface methodsFor: 'acessing' stamp: 'pv 12/5/2013 19:54'!
setWatchhand: anAngleInDegrees
	^ proxy ifGetWatchhand rotationDegreesFromMidnightPosition: anAngleInDegrees! !

!Dial05Interface methodsFor: 'acessing' stamp: 'pv 12/5/2013 19:52'!
startStepping
	^ proxy ifGetWatchhand startStepping! !

!Dial05Interface methodsFor: 'acessing' stamp: 'pv 12/5/2013 19:52'!
stopStepping
	^ proxy ifGetWatchhand stopStepping! !

PolygonMorph subclass: #ResizableWatchHand05
	instanceVariableNames: 'watchHand04m watchHand04 midnightVertices dial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype05'!

!ResizableWatchHand05 class methodsFor: 'instance creation' stamp: 'pv 12/3/2013 21:00'!
newFrom: aDial 
	| watchHand05 |
	watchHand05 := self new.
	watchHand05 setDial: aDial.
	^ watchHand05! !

!ResizableWatchHand05 methodsFor: 'accessing' stamp: 'pv 12/4/2013 22:58'!
getMovingWatchhand
	^watchHand04! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:52'!
initialize
	super initialize.
	watchHand04m := WatchHand05 new.
	watchHand04 := WatchHand05 new.
	watchHand04 setMidnightWatchhand: watchHand04m! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/3/2013 20:53'!
pvtAddMidnightWatchhandFrom: anArray 
	watchHand04m setMidnightVerticesFrom: anArray.
	watchHand04m setVertices: anArray;
		 visible: false.
	dial
		addMorph: watchHand04m
		fullFrame: (LayoutConcentricFrame
				left: 0.3
				right: 0.3
				top: 0.9
				bottom: 0.3)! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/3/2013 20:53'!
pvtAddRotatingWatchhand
	watchHand04
		setInitialMidnightVerticesFromCenter: dial center
		andRadius: dial extent x / 2
		withFraction: 0.9.
	dial addMorph: watchHand04! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:30'!
setDial: aDial 
	dial := aDial! !

!ResizableWatchHand05 methodsFor: 'initialization' stamp: 'pv 12/3/2013 20:53'!
setInitialMidnightVerticesFromCenter: aPoint andRadius: aFloat withFraction: aFractionFloat 
	"2013-09-29pv: vertices sind immer Float"
	| lozengeLengthFromCenter lozengeWidthFromCenter a |
	lozengeLengthFromCenter := 3 max: aFloat * aFractionFloat.
	lozengeWidthFromCenter := 1 max: aFloat * (aFractionFloat / 3).
	a := Array
				with: aPoint + (0 @ lozengeWidthFromCenter)
				with: aPoint + (-1 * lozengeWidthFromCenter @ 0)
				with: aPoint + (0 @ -1 * lozengeLengthFromCenter)
				with: aPoint + (lozengeWidthFromCenter @ 0).
	self pvtAddMidnightWatchhandFrom: a.
	self pvtAddRotatingWatchhand! !

PolygonMorph subclass: #WatchHand05
	instanceVariableNames: 'midnightWatchhand midnightVertices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype05'!

!WatchHand05 class methodsFor: 'geometry' stamp: 'pv 12/2/2013 20:19'!
inDegrees: aTime 
	"080413 should be a class method."
	| timeValue delta |
	delta := 0.0.
	timeValue := (aTime perform: #seconds) asFloat.
	^ 360 * timeValue / 60! !

!WatchHand05 methodsFor: 'accessing - properties' stamp: 'pv 12/2/2013 20:16'!
isMovingWatchhand
	self layoutFrame
		ifNil: [^ true].
	^ false! !

!WatchHand05 methodsFor: 'geometry' stamp: 'pv 12/5/2013 20:29'!
rotationDegreesFromMidnightPosition
	^ self rotationDegrees! !

!WatchHand05 methodsFor: 'geometry' stamp: 'pv 12/2/2013 20:15'!
rotationDegreesFromMidnightPosition: degrees 
	| flex center |
	(center := self valueOfProperty: #referencePosition)
		ifNil: [self setProperty: #referencePosition toValue: (center := self bounds center)].
	flex := (MorphicTransform offset: center negated)
				withAngle: degrees degreesToRadians.
	self
		setVertices: (vertices
				collect: [:v | (flex transform: v)
						- flex offset]).
	self forwardDirection: degrees! !

!WatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:17'!
setInitialMidnightVerticesFromCenter: aPoint andRadius: aFloat withFraction: aFractionFloat 
	"2013-09-29pv: vertices sind immer Float"
	| lozengeLengthFromCenter lozengeWidthFromCenter |
	lozengeLengthFromCenter := 3 max: aFloat * aFractionFloat.
	lozengeWidthFromCenter := 1 max: aFloat * (aFractionFloat / 3).
	midnightVertices := Array
				with: aPoint + (0 @ lozengeWidthFromCenter)
				with: aPoint + (-1 * lozengeWidthFromCenter @ 0)
				with: aPoint + (0 @ -1 * lozengeLengthFromCenter)
				with: aPoint + (lozengeWidthFromCenter @ 0).
	self setVertices: midnightVertices! !

!WatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:17'!
setMidnightVerticesFrom: anArray 
	midnightVertices := anArray! !

!WatchHand05 methodsFor: 'initialization' stamp: 'pv 12/2/2013 20:17'!
setMidnightWatchhand: aWatchHand 
	midnightWatchhand := aWatchHand! !

!WatchHand05 methodsFor: 'stepping and presenter' stamp: 'pv 12/2/2013 20:15'!
step
	self isMovingWatchhand
		ifFalse: [^ self].
	midnightWatchhand
		ifNil: [^ self].
	vertices := midnightWatchhand vertices.
	self setRotationCenterFrom: owner center.
	self
		rotationDegreesFromMidnightPosition: (self class inDegrees: DateAndTime now)! !

!WatchHand05 methodsFor: 'stepping and presenter' stamp: 'pv 12/2/2013 20:15'!
stepTime
	^ 1000! !

!LayoutConcentricFrame methodsFor: '*pvpub-analogclockprototype05' stamp: 'pv 1/3/2014 01:26'!
layout: submorphBounds given: oldMorphBounds in: newMorphBounds 
	"Return center and end point of the concentrically embedded
	morph"
	| left right top bottom newRadius |
	newRadius := newMorphBounds center y - newMorphBounds origin y min: newMorphBounds center x - newMorphBounds origin x.
	left := newMorphBounds center x - (newRadius * leftFraction).
	right := newMorphBounds center x + (newRadius * rightFraction).
	top := newMorphBounds center y - (newRadius * topFraction).
	bottom := newMorphBounds center y + (newRadius * bottomFraction).
	^ (left @ top corner: right @ bottom) rounded! !

!LayoutConcentricFrame methodsFor: '*pvpub-analogclockprototype05' stamp: 'pv 9/2/2013 22:32'!
left: leftFractionOrNil right: rightFractionOrNil top: topFractionOrNil bottom: bottomFractionOrNil
	leftFraction := leftFractionOrNil.
	rightFraction := rightFractionOrNil.
		topFraction := topFractionOrNil.
		bottomFraction := bottomFractionOrNil.! !

!LayoutConcentricFrame methodsFor: '*pvpub-analogclockprototype05' stamp: 'pv 1/3/2014 01:07'!
minExtentFrom: minExtent 
	"Return the minimal extent the given bounds can be
	represented in"
	| width height left right top bottom |
	left := leftFraction
				ifNil: [1.0].
	right := rightFraction
				ifNil: [1.0].
	width := left = right
				ifTrue: [0]
				ifFalse: [minExtent x / (right - left)].
	top := topFraction
				ifNil: [0.0].
	bottom := bottomFraction
				ifNil: [1.0].
	height := bottom = top
				ifTrue: [0]
				ifFalse: [minExtent y / (bottom - top)].
	leftOffset
		ifNotNil: [width := width + leftOffset].
	rightOffset
		ifNotNil: [width := width + rightOffset].
	topOffset
		ifNotNil: [height := height + topOffset].
	bottomOffset
		ifNotNil: [height := height + bottomOffset].
	^ width truncated @ height truncated! !
